class Admin::ApplicationFormItemsController < OrbitAdminController

  def initialize
    super
    @app_title = 'application_form'
  end

  def index
    @application_form_items = ApplicationFormItem.all
    @url = admin_application_form_item_path(@application_form_items)
  end

  def create
    @application_form_item = ApplicationFormItem.new(application_form_item_params)
    @application_form_item.save
    redirect_to request.referer, :status => 303
  end

  def create_in_form
    @application_form_item = ApplicationFormItem.new(application_form_item_params)
    @application_form_item.saveapplication_form_item
    render :json => {:id=>@application_form_item.id.to_s, :title=>@application_form_item.title}.to_json ,:layout => false
  end

  def update
    @application_form_item = ApplicationFormItem.find(params[:id])
    @application_form_item.update_attributes(application_form_item_params)
    redirect_to request.referer, :status => 303
  end

  def toggle
    @application_form_item = ApplicationFormItem.find(params[:id])
    @application_form_item.save!
    redirect_to request.referer, :status => 303
  end

  def delete_items
    items = ApplicationFormItem.find(params[:ids].split(',')) rescue nil
    if items
      items.each(&:destroy)
    end
    redirect_to request.referer, :status => 303
  end


  private

  def application_form_item_params
    params.require(:application_form_item).permit!
  end

end
