# encoding: utf-8
class Admin::ApplicationFormReviewResultsController < OrbitAdminController
  include Admin::ApplicationFormsHelper
  before_action ->(module_app = @app_title) { set_variables module_app }
  before_action :set_application_form,:check_permission_for_application_form
  def initialize
    super
    @app_title = "application_form"
  end
  def set_application_form
    @application_form_signup_contribute = ApplicationFormSignupContribute.find(params[:id]) rescue nil
    @application_form_review_result = @application_form_signup_contribute.application_form_review_result rescue nil
    @application_form_review_result = ApplicationFormReviewResult.new if @application_form_review_result.nil?
    @application_form = @application_form_signup_contribute.application_form_signup.application_form_main rescue nil
  end
  def check_manager_for_application_form
    OrbitHelper.set_params(params,current_user)
    access_level = OrbitHelper.user_access_level?
    if (access_level.nil? || access_level == "user")
      if (@application_form.organizer_id != current_user.member_profile_id rescue true)
        render_401
      end
    end
  end
  def check_permission_for_application_form
    OrbitHelper.set_params(params,current_user)
    access_level = OrbitHelper.user_access_level?
    if (access_level.nil? || access_level == "user")
      unless (@application_form.reviewer_ids.include?(current_user.member_profile_id.to_s) rescue false) || (@application_form.organizer_id == current_user.member_profile_id rescue false)
        render_401
      else
        @user_authenticated_categories = ['all']
      end
    end
  end
  def edit
    OrbitHelper.set_params(params,current_user)
    @form_index = 0
    params[:controller] = "admin/application_forms"
    params[:action] = "edit_application_form_review"
  end

  def update
    @application_form_signup_contribute.update_attributes(application_form_signup_contribute_params)
    redirect_to params[:referer_url]
  end

  private

  def application_form_signup_contribute_params
    params.require(:application_form_signup_contribute).permit!
  end
end
