# encoding: utf-8
class Admin::ApplicationFormSubmissionValuesController < OrbitAdminController
  include Admin::ApplicationFormsHelper
  before_action ->(module_app = @app_title) { set_variables module_app }
  before_action :set_application_form,:check_manager_for_application_form
  def initialize
    super
    @app_title = "application_form"
  end
  def set_application_form
    @application_form_submission_value = ApplicationFormSubmissionValue.find(params[:id]) rescue nil
    @application_form_submission_field = @application_form_submission_value.application_form_submission_field rescue nil
    @con = @application_form_submission_value.application_form_signup_contribute rescue nil
    @application_form = @application_form_submission_value.application_form_submission_field.application_form_main rescue nil
  end
  def check_manager_for_application_form
    OrbitHelper.set_params(params,current_user)
    access_level = OrbitHelper.user_access_level?
    if (access_level.nil? || access_level == "user")
      if (@application_form.organizer_id != current_user.member_profile_id rescue true)
        render_401
      end
    end
  end
  def edit
    OrbitHelper.set_params(params,current_user)
    @form_index = 0
    render :layout =>false
  end

  def update
    begin
      @application_form_submission_value.update_attributes(application_form_submission_value_params)
      render :json => {:success=>true,:val=>@application_form_submission_value.get_value_by_locale(I18n.locale)}
    rescue => e
      render :json => {:success=>false,:error=>e.to_s}
    end
  end

  private

  def application_form_submission_value_params
    params.require(:application_form_submission_values).permit!.values.first
  end
end
